/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignExecution type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignExecution{}

// CampaignExecution struct for CampaignExecution
type CampaignExecution struct {
	Id *string `json:"id,omitempty"`
	CampaignId *string `json:"campaign_id,omitempty"`
	Status *string `json:"status,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	ContactId *string `json:"contact_id,omitempty"`
}

// NewCampaignExecution instantiates a new CampaignExecution object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignExecution() *CampaignExecution {
	this := CampaignExecution{}
	return &this
}

// NewCampaignExecutionWithDefaults instantiates a new CampaignExecution object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignExecutionWithDefaults() *CampaignExecution {
	this := CampaignExecution{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *CampaignExecution) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignExecution) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *CampaignExecution) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *CampaignExecution) SetId(v string) {
	o.Id = &v
}

// GetCampaignId returns the CampaignId field value if set, zero value otherwise.
func (o *CampaignExecution) GetCampaignId() string {
	if o == nil || IsNil(o.CampaignId) {
		var ret string
		return ret
	}
	return *o.CampaignId
}

// GetCampaignIdOk returns a tuple with the CampaignId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignExecution) GetCampaignIdOk() (*string, bool) {
	if o == nil || IsNil(o.CampaignId) {
		return nil, false
	}
	return o.CampaignId, true
}

// HasCampaignId returns a boolean if a field has been set.
func (o *CampaignExecution) HasCampaignId() bool {
	if o != nil && !IsNil(o.CampaignId) {
		return true
	}

	return false
}

// SetCampaignId gets a reference to the given string and assigns it to the CampaignId field.
func (o *CampaignExecution) SetCampaignId(v string) {
	o.CampaignId = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *CampaignExecution) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignExecution) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *CampaignExecution) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *CampaignExecution) SetStatus(v string) {
	o.Status = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *CampaignExecution) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignExecution) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *CampaignExecution) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *CampaignExecution) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetContactId returns the ContactId field value if set, zero value otherwise.
func (o *CampaignExecution) GetContactId() string {
	if o == nil || IsNil(o.ContactId) {
		var ret string
		return ret
	}
	return *o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignExecution) GetContactIdOk() (*string, bool) {
	if o == nil || IsNil(o.ContactId) {
		return nil, false
	}
	return o.ContactId, true
}

// HasContactId returns a boolean if a field has been set.
func (o *CampaignExecution) HasContactId() bool {
	if o != nil && !IsNil(o.ContactId) {
		return true
	}

	return false
}

// SetContactId gets a reference to the given string and assigns it to the ContactId field.
func (o *CampaignExecution) SetContactId(v string) {
	o.ContactId = &v
}

func (o CampaignExecution) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignExecution) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.CampaignId) {
		toSerialize["campaign_id"] = o.CampaignId
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.ContactId) {
		toSerialize["contact_id"] = o.ContactId
	}
	return toSerialize, nil
}

type NullableCampaignExecution struct {
	value *CampaignExecution
	isSet bool
}

func (v NullableCampaignExecution) Get() *CampaignExecution {
	return v.value
}

func (v *NullableCampaignExecution) Set(val *CampaignExecution) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignExecution) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignExecution) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignExecution(val *CampaignExecution) *NullableCampaignExecution {
	return &NullableCampaignExecution{value: val, isSet: true}
}

func (v NullableCampaignExecution) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignExecution) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


